package org.codehaus.mojo.animal_sniffer.maven;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.apache.maven.plugin.AbstractMojo;
import org.apache.maven.plugin.MojoExecutionException;

/**
 * Display help information on animal-sniffer-maven-plugin.<br/> Call <pre>  mvn animal-sniffer:help -Ddetail=true -Dgoal=&lt;goal-name&gt;</pre> to display parameter details.
 *
 * @version generated on Thu Jul 07 15:24:31 IST 2011
 * @author org.apache.maven.tools.plugin.generator.PluginHelpGenerator (version 2.7)
 * @goal help
 * @requiresProject false
 * @threadSafe
 */
public class HelpMojo
    extends AbstractMojo
{
    /**
     * If <code>true</code>, display all settable properties for each goal.
     * 
     * @parameter expression="${detail}" default-value="false"
     */
    private boolean detail;

    /**
     * The name of the goal for which to show help. If unspecified, all goals will be displayed.
     * 
     * @parameter expression="${goal}"
     */
    private java.lang.String goal;

    /**
     * The maximum length of a display line, should be positive.
     * 
     * @parameter expression="${lineLength}" default-value="80"
     */
    private int lineLength;

    /**
     * The number of spaces per indentation level, should be positive.
     * 
     * @parameter expression="${indentSize}" default-value="2"
     */
    private int indentSize;


    /** {@inheritDoc} */
    public void execute()
        throws MojoExecutionException
    {
        if ( lineLength <= 0 )
        {
            getLog().warn( "The parameter 'lineLength' should be positive, using '80' as default." );
            lineLength = 80;
        }
        if ( indentSize <= 0 )
        {
            getLog().warn( "The parameter 'indentSize' should be positive, using '2' as default." );
            indentSize = 2;
        }

        StringBuffer sb = new StringBuffer();

        append( sb, "org.codehaus.mojo:animal-sniffer-maven-plugin:1.7", 0 );
        append( sb, "", 0 );

        append( sb, "Animal Sniffer Maven Plugin", 0 );
        append( sb, "Animal Sniffer Maven Plugin.", 1 );
        append( sb, "", 0 );

        if ( goal == null || goal.length() <= 0 )
        {
            append( sb, "This plugin has 3 goals:", 0 );
            append( sb, "", 0 );
        }

        if ( goal == null || goal.length() <= 0 || "build".equals( goal ) )
        {
            append( sb, "animal-sniffer:build", 0 );
            append( sb, "Generates an API Signature from at least one of: the java runtime, the module dependencies and the module classes.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "classesDirectory", 2 );
                append( sb, "Where to find this modules classes.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${project.build.outputDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "classifier", 2 );
                append( sb, "The classifier to add to the generated signatures.", 3 );
                append( sb, "", 0 );

                append( sb, "excludeClasses", 2 );
                append( sb, "Classes to exclude from generating signatures of.", 3 );
                append( sb, "", 0 );

                append( sb, "excludeDependencies", 2 );
                append( sb, "A list of artifact patterns to exclude. Follows the pattern \'groupId:artifactId:type:classifier:version\'.", 3 );
                append( sb, "", 0 );

                append( sb, "includeClasses", 2 );
                append( sb, "Classes to generate signatures of.", 3 );
                append( sb, "", 0 );

                append( sb, "includeDependencies", 2 );
                append( sb, "A list of artifact patterns to include. Follows the pattern \'groupId:artifactId:type:classifier:version\'.", 3 );
                append( sb, "", 0 );

                append( sb, "includeJavaHome (Default: true)", 2 );
                append( sb, "Should the signatures from java home be included.", 3 );
                append( sb, "Expression: ${includeJavaHome}", 3 );
                append( sb, "", 0 );

                append( sb, "includeModuleClasses (Default: true)", 2 );
                append( sb, "Should the signatures from this module\'s classes be included..", 3 );
                append( sb, "Expression: ${includeJavaHome}", 3 );
                append( sb, "", 0 );

                append( sb, "javaHome", 2 );
                append( sb, "The java home to generate the signatures of, if not specified only the signatures of dependencies will be included. This parameter is overridden by javaHomeClassPath. This parameter overrides jdk and any java home specified by maven-toolchains-plugin.", 3 );
                append( sb, "Expression: ${javaHome}", 3 );
                append( sb, "", 0 );

                append( sb, "javaHomeClassPath", 2 );
                append( sb, "Use this configuration option only if the automatic boot classpath detection does not work for the specific javaHome or jdk. For example, the automatic boot classpath detection does not work with Sun Java 1.1. This parameter overrides javaHome, jdk and the maven-toolchains-plugin.", 3 );
                append( sb, "", 0 );

                append( sb, "jbcpdArtifactId (Default: java-boot-classpath-detector)", 2 );
                append( sb, "The artifactId of the Java Boot Classpath Detector to use. The plugin\'s dependencies will be searched for a dependency of type jar with this artifactId and the groupId specified in jbcpdGroupId. The dependency should be a standalone executable jar file which outputs the java boot classpath as a single line separated using File.pathSeparatorChar or else exits with a non-zero return code if it cannot determine the java boot classpath.", 3 );
                append( sb, "", 0 );

                append( sb, "jbcpdGroupId (Default: ${plugin.groupId})", 2 );
                append( sb, "The groupId of the Java Boot Classpath Detector to use. The plugin\'s dependencies will be searched for a dependency of type jar with this groupId and the artifactId specified in jbcpdArtifactId. The dependency should be a standalone executable jar file which outputs the java boot classpath as a single line separated using File.pathSeparatorChar or else exits with a non-zero return code if it cannot determine the java boot classpath.", 3 );
                append( sb, "", 0 );

                append( sb, "jdk", 2 );
                append( sb, "The JDK Toolchain to use. This parameter can be overridden by javaHome or javaHomeClassPath. This parameter overrides any toolchain specified with maven-toolchains-plugin.", 3 );
                append( sb, "", 0 );

                append( sb, "outputDirectory", 2 );
                append( sb, "Where to put the generated signatures.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${project.build.directory}", 3 );
                append( sb, "", 0 );

                append( sb, "signaturesName", 2 );
                append( sb, "The name of the generated signatures.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${project.build.finalName}", 3 );
                append( sb, "", 0 );

                append( sb, "skipIfNoJavaHome (Default: false)", 2 );
                append( sb, "Should no signatures be generated if no java home is available.", 3 );
                append( sb, "Expression: ${skipIfNoJavaHome}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "check".equals( goal ) )
        {
            append( sb, "animal-sniffer:check", 0 );
            append( sb, "Checks the classes compiled by this module.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "ignoreDependencies (Default: true)", 2 );
                append( sb, "Should dependencies be ignored.", 3 );
                append( sb, "", 0 );

                append( sb, "ignores", 2 );
                append( sb, "Class names to ignore signatures for (wildcards accepted).", 3 );
                append( sb, "", 0 );

                append( sb, "signature", 2 );
                append( sb, "Signature module to use.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "", 0 );

                append( sb, "skip (Default: false)", 2 );
                append( sb, "Should signature checking be skipped?", 3 );
                append( sb, "Expression: ${animal.sniffer.skip}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "help".equals( goal ) )
        {
            append( sb, "animal-sniffer:help", 0 );
            append( sb, "Display help information on animal-sniffer-maven-plugin.\nCall\n\u00a0\u00a0mvn\u00a0animal-sniffer:help\u00a0-Ddetail=true\u00a0-Dgoal=<goal-name>\nto display parameter details.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "detail (Default: false)", 2 );
                append( sb, "If true, display all settable properties for each goal.", 3 );
                append( sb, "Expression: ${detail}", 3 );
                append( sb, "", 0 );

                append( sb, "goal", 2 );
                append( sb, "The name of the goal for which to show help. If unspecified, all goals will be displayed.", 3 );
                append( sb, "Expression: ${goal}", 3 );
                append( sb, "", 0 );

                append( sb, "indentSize (Default: 2)", 2 );
                append( sb, "The number of spaces per indentation level, should be positive.", 3 );
                append( sb, "Expression: ${indentSize}", 3 );
                append( sb, "", 0 );

                append( sb, "lineLength (Default: 80)", 2 );
                append( sb, "The maximum length of a display line, should be positive.", 3 );
                append( sb, "Expression: ${lineLength}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( getLog().isInfoEnabled() )
        {
            getLog().info( sb.toString() );
        }
    }

    /**
     * <p>Repeat a String <code>n</code> times to form a new string.</p>
     *
     * @param str String to repeat
     * @param repeat number of times to repeat str
     * @return String with repeated String
     * @throws NegativeArraySizeException if <code>repeat < 0</code>
     * @throws NullPointerException if str is <code>null</code>
     */
    private static String repeat( String str, int repeat )
    {
        StringBuffer buffer = new StringBuffer( repeat * str.length() );

        for ( int i = 0; i < repeat; i++ )
        {
            buffer.append( str );
        }

        return buffer.toString();
    }

    /** 
     * Append a description to the buffer by respecting the indentSize and lineLength parameters.
     * <b>Note</b>: The last character is always a new line.
     * 
     * @param sb The buffer to append the description, not <code>null</code>.
     * @param description The description, not <code>null</code>.
     * @param indent The base indentation level of each line, must not be negative.
     */
    private void append( StringBuffer sb, String description, int indent )
    {
        for ( Iterator it = toLines( description, indent, indentSize, lineLength ).iterator(); it.hasNext(); )
        {
            sb.append( it.next().toString() ).append( '\n' );
        }
    }

    /** 
     * Splits the specified text into lines of convenient display length.
     * 
     * @param text The text to split into lines, must not be <code>null</code>.
     * @param indent The base indentation level of each line, must not be negative.
     * @param indentSize The size of each indentation, must not be negative.
     * @param lineLength The length of the line, must not be negative.
     * @return The sequence of display lines, never <code>null</code>.
     * @throws NegativeArraySizeException if <code>indent < 0</code>
     */
    private static List toLines( String text, int indent, int indentSize, int lineLength )
    {
        List lines = new ArrayList();

        String ind = repeat( "\t", indent );
        String[] plainLines = text.split( "(\r\n)|(\r)|(\n)" );
        for ( int i = 0; i < plainLines.length; i++ )
        {
            toLines( lines, ind + plainLines[i], indentSize, lineLength );
        }

        return lines;
    }

    /** 
     * Adds the specified line to the output sequence, performing line wrapping if necessary.
     * 
     * @param lines The sequence of display lines, must not be <code>null</code>.
     * @param line The line to add, must not be <code>null</code>.
     * @param indentSize The size of each indentation, must not be negative.
     * @param lineLength The length of the line, must not be negative.
     */
    private static void toLines( List lines, String line, int indentSize, int lineLength )
    {
        int lineIndent = getIndentLevel( line );
        StringBuffer buf = new StringBuffer( 256 );
        String[] tokens = line.split( " +" );
        for ( int i = 0; i < tokens.length; i++ )
        {
            String token = tokens[i];
            if ( i > 0 )
            {
                if ( buf.length() + token.length() >= lineLength )
                {
                    lines.add( buf.toString() );
                    buf.setLength( 0 );
                    buf.append( repeat( " ", lineIndent * indentSize ) );
                }
                else
                {
                    buf.append( ' ' );
                }
            }
            for ( int j = 0; j < token.length(); j++ )
            {
                char c = token.charAt( j );
                if ( c == '\t' )
                {
                    buf.append( repeat( " ", indentSize - buf.length() % indentSize ) );
                }
                else if ( c == '\u00A0' )
                {
                    buf.append( ' ' );
                }
                else
                {
                    buf.append( c );
                }
            }
        }
        lines.add( buf.toString() );
    }

    /** 
     * Gets the indentation level of the specified line.
     * 
     * @param line The line whose indentation level should be retrieved, must not be <code>null</code>.
     * @return The indentation level of the line.
     */
    private static int getIndentLevel( String line )
    {
        int level = 0;
        for ( int i = 0; i < line.length() && line.charAt( i ) == '\t'; i++ )
        {
            level++;
        }
        for ( int i = level + 1; i <= level + 4 && i < line.length(); i++ )
        {
            if ( line.charAt( i ) == '\t' )
            {
                level++;
                break;
            }
        }
        return level;
    }
}
